import java.util.*;
import java.io.*;
import java.math.*;

public class BB {
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);

		long k = in.nextLong() + 1;
		long s = in.nextLong();

		long l = k;
		long r = s;
		while (r - l > 1) {
			long m = (r + l) / 2;
			BigInteger tmp = sum(k, m);
			if (tmp.compareTo(BigInteger.valueOf(s)) > 0) {
				r = m;
			} else {
				l = m;
			}
		}

		BigInteger d = BigInteger.valueOf(l - k + 1);
		BigInteger sum = sum(k, l);

		//long res = (s - sum);
		BigInteger res = BigInteger.valueOf(s).subtract(sum);
		if (res.mod(d).compareTo(BigInteger.ZERO) == 0) {
			//res /= d;
			res = res.divide(d);
		} else {
			//res /= d;
			//res++;
			res = res.divide(d);
			res = res.add(BigInteger.ONE);
		}

		System.out.println(res.add(BigInteger.valueOf(k)).subtract(BigInteger.ONE));
	}

	public static BigInteger sum(long l, long r) {
		BigInteger a = BigInteger.valueOf(l).add(BigInteger.valueOf(r));
		BigInteger b = BigInteger.valueOf(r).subtract(BigInteger.valueOf(l)).add(BigInteger.ONE);
		return a.multiply(b).divide(BigInteger.valueOf(2));
	}
}
