import java.io.*;
import java.util.*;

public class DD {
	public void solve() throws IOException {
		int k = nextInt();
		int n = nextInt();
		int m = nextInt();

		int a[] = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = i;
		}

		// HashMap<Integer, Integer> l = new HashMap<Integer, Integer>();
		// HashMap<Integer, Integer> r = new HashMap<Integer, Integer>();
		//HashMap<Integer, Integer> id = new HashMap<Integer, Integer>();
		ArrayList<Integer> l[] = new ArrayList[m+1];
		ArrayList<Integer> r[] = new ArrayList[m+1];
		for (int i = 0; i <= m; i++) {
			l[i] = new ArrayList<Integer>();
			r[i] = new ArrayList<Integer>();
		}
		HashSet<Integer> key = new HashSet<Integer>();

		int cur = 0;
		for (int i = 0; i < n; i++) {
			int c = nextInt();
			int v = nextInt();
			key.add(v);
			l[v].add(cur);
			r[v].add(cur + c - 1);
			cur += c;
		}

		Integer b[] = key.toArray(new Integer[key.size()]);

		Arrays.sort(b);
		int res = Integer.MAX_VALUE;
		while (b[0] != -1) {
			int resc = 0;
			for (int i = 0; i < b.length; i++) {
				int le;
				int re;
				if (i == 0) {
					le = 0;
					re = (1 << k) - 1;

					int pt = le;
					while (pt <= re) {
						int len = 1;
						while (true) {
							int nlen = len << 1;
							if (pt + nlen - 1 > re || (pt % nlen != 0)) {
								break;
							} else {
								len = nlen;
							}
						}
						pt += len;
						resc++;
					}
				} else {
					for (int j = 0; j < l[b[i]].size(); j++) {
						le = l[b[i]].get(j);
						re = r[b[i]].get(j);
						int pt = le;
						while (pt <= re) {
							int len = 1;
							while (true) {
								int nlen = len << 1;
								if (pt + nlen - 1 > re || (pt % nlen != 0)) {
									break;
								} else {
									len = nlen;
								}
							}
							pt += len;
							resc++;
						}
					}
				}

			}
			res = Math.min(res, resc);
			b = nextPerm(b);
		}

		out.println(res);
	}

	public Integer[] nextPerm(Integer a[]) {
		int n = a.length;
		int i = n - 2;
		while (i >= 0 && a[i] > a[i + 1]) {
			i--;
		}
		if (i == -1) {
			a[0] = -1;
			return a;
		}

		int j = n - 1;
		while (a[i] > a[j]) {
			j--;
		}

		int x = a[i];
		a[i] = a[j];
		a[j] = x;

		for (int u = i + 1; u < (n + i + 1) / 2; u++) {
			x = a[u];
			a[u] = a[n - u + i];
			a[n - u + i] = x;
		}

		return a;
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new DD().run();
	}

}
