import java.util.*;
import java.io.*;

public class B {
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);

		long a = in.nextLong();
		long b = in.nextLong();
		long k = in.nextLong();
		long res = 0;

		long cube_low = croot_u(a);
		long cube_high = croot_d(b);

		for (long i = cube_low; i <= cube_high; i++) {
			long x = i * i * i;

			long delta = 0;

			long l = sqrt_u(x - k);
			l = Math.max(l, a);

			long r = sqrt_d(x + k);
			r = Math.min(r, b);
			delta += (Math.max(r - l + 1, 0));
			res += delta;
			//System.out.println(delta);
//			if (delta > 0)
//				System.out.println(x + ": " + (long) (l * l) + "-" + (long) (r * r) + (" ") + (delta));
		}

		System.out.println(res);
	}

	public static long croot_d(long x) {
		long l = 0;
		long r = 1000001;
		while (r - l > 1) {
			long m = (r + l) / 2;
			if (m * m * m <= x) {
				l = m;
			} else {
				r = m;
			}
		}
		return l;
	}

	public static long croot_u(long x) {
		long l = 0;
		long r = 1000001;
		while (r - l > 1) {
			long m = (r + l) / 2;
			if (m * m * m < x) {
				l = m;
			} else {
				r = m;
			}
		}
		return r;
	}

	public static long sqrt_d(long x) {
		long l = 0;
		long r = 1000000001;
		while (r - l > 1) {
			long m = (r + l) / 2;
			if (m * m <= x) {
				l = m;
			} else {
				r = m;
			}
		}
		return l;
	}

	public static long sqrt_u(long x) {
		long l = 0;
		long r = 1000000001;
		while (r - l > 1) {
			long m = (r + l) / 2;
			if (m * m < x) {
				l = m;
			} else {
				r = m;
			}
		}
		return r;
	}
}
