import java.io.*;
import java.util.*;

public class CC2 {
	static int revert;
	static ArrayList<Integer> a[];
	static boolean vis[];

	public void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		a = new ArrayList[n];
		for (int i = 0; i < n; i++) {
			a[i] = new ArrayList<Integer>();
		}
		vis = new boolean[n];
		for (int i = 1; i < n; i++) {
			int t = nextInt() - 1;
			a[t].add(i);
		}

		int dist = DFS(0, 1);

		out.println(1L * revert + 1L * 2 * (m - 1) * dist);
	}

	public int DFS(int x, int d) {
		vis[x] = true;
		// LOLWAT
		int max1 = 0;
		int max2 = 0;
		int ret = 0;

		for (int z : a[x]) {
			if (!vis[z]) {

				int depth = DFS(z, d + 1);
				if (depth > max2) {
					max2 = depth;
				}
				if (max2 > max1) {
					int tmp = max2;
					max2 = max1;
					max1 = tmp;
				}
				revert = Math.max(revert, max1 - d + max2 - d + 1);
				ret = Math.max(ret, max1);
			}
		}
		if (ret == 0)
			return d;
		return ret;
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new CC2().run();
	}

}